@echo off

@REM Run cmd in Admin -S
%1 mshta vbscript:CreateObject("Shell.Application").ShellExecute("cmd.exe","/c %~s0 ::","","runas",1)(window.close)&&exit
cd /d "%~dp0"
@REM Run cmd in Admin -E

echo =================================================================
echo Update VBIOS Utility                                        V1.02
echo Author : Dept. SW3                                               
echo Copyright 2021 (c) COMPAL ELECTRONICS INC.  All rights reserved .
echo =================================================================

@REM Set Config Variable -S
echo Loading Config...
@REM Set Project SSID
FOR /F "tokens=3" %%b in ('Find "SSID1" Config.ini') do set SSID1=%%b
FOR /F "tokens=3" %%b in ('Find "SSID2" Config.ini') do set SSID2=%%b
FOR /F "tokens=3" %%b in ('Find "SSID3" Config.ini') do set SSID3=%%b
FOR /F "tokens=3" %%b in ('Find "SSID4" Config.ini') do set SSID4=%%b
FOR /F "tokens=3" %%b in ('Find "SSID5" Config.ini') do set SSID5=%%b
FOR /F "tokens=3" %%b in ('Find "SSID6" Config.ini') do set SSID6=%%b
FOR /F "tokens=3" %%b in ('Find "SSID7" Config.ini') do set SSID7=%%b
FOR /F "tokens=3" %%b in ('Find "SSID8" Config.ini') do set SSID8=%%b
@REM Set VBIOS
FOR /F "tokens=3" %%b in ('Find "DeviceID1" Config.ini') do set DeviceID1=%%b
FOR /F "tokens=3" %%b in ('Find "EXE1" Config.ini') do set EXE1=%%b
FOR /F "tokens=3" %%b in ('Find "Version1" Config.ini') do set Version1=%%b
FOR /F "tokens=3" %%b in ('Find "DeviceID2" Config.ini') do set DeviceID2=%%b
FOR /F "tokens=3" %%b in ('Find "EXE2" Config.ini') do set EXE2=%%b
FOR /F "tokens=3" %%b in ('Find "Version2" Config.ini') do set Version2=%%b
FOR /F "tokens=3" %%b in ('Find "DeviceID3" Config.ini') do set DeviceID3=%%b
FOR /F "tokens=3" %%b in ('Find "EXE3" Config.ini') do set EXE3=%%b
FOR /F "tokens=3" %%b in ('Find "Version3" Config.ini') do set Version3=%%b
FOR /F "tokens=3" %%b in ('Find "DeviceID4" Config.ini') do set DeviceID4=%%b
FOR /F "tokens=3" %%b in ('Find "EXE4" Config.ini') do set EXE4=%%b
FOR /F "tokens=3" %%b in ('Find "Version4" Config.ini') do set Version4=%%b
FOR /F "tokens=3" %%b in ('Find "DeviceID5" Config.ini') do set DeviceID5=%%b
FOR /F "tokens=3" %%b in ('Find "EXE5" Config.ini') do set EXE5=%%b
FOR /F "tokens=3" %%b in ('Find "Version5" Config.ini') do set Version5=%%b
FOR /F "tokens=3" %%b in ('Find "DeviceID6" Config.ini') do set DeviceID6=%%b
FOR /F "tokens=3" %%b in ('Find "EXE6" Config.ini') do set EXE6=%%b
FOR /F "tokens=3" %%b in ('Find "Version6" Config.ini') do set Version6=%%b
FOR /F "tokens=3" %%b in ('Find "DeviceID7" Config.ini') do set DeviceID7=%%b
FOR /F "tokens=3" %%b in ('Find "EXE7" Config.ini') do set EXE7=%%b
FOR /F "tokens=3" %%b in ('Find "Version7" Config.ini') do set Version7=%%b
FOR /F "tokens=3" %%b in ('Find "DeviceID8" Config.ini') do set DeviceID8=%%b
FOR /F "tokens=3" %%b in ('Find "EXE8" Config.ini') do set EXE8=%%b
FOR /F "tokens=3" %%b in ('Find "Version8" Config.ini') do set Version8=%%b
@REM Set Config Variable -E

@REM Load device settings -S
echo Loading Device Settings...
cd VBIOS
FOR /F "tokens=5" %%b in ('MyNvAPI.exe ^| Find "GPU Sub ID"') do set SSID=0x%%b
timeout /T 1
FOR /F "tokens=5" %%b in ('MyNvAPI.exe ^| Find "GPU Device ID"') do set DeviceID=0x%%b
timeout /T 1
FOR /F "tokens=4" %%b in ('MyNvAPI.exe ^| Find "VBIOS Version"') do set Version=%%b
@REM Load device settings -E

@REM Check SSID -S
echo Checking Project...
if /I %SSID:1025=% == %SSID1% goto CheckDeviceID
if /I %SSID:1025=% == %SSID2% goto CheckDeviceID
if /I %SSID:1025=% == %SSID3% goto CheckDeviceID
if /I %SSID:1025=% == %SSID4% goto CheckDeviceID
if /I %SSID:1025=% == %SSID5% goto CheckDeviceID
if /I %SSID:1025=% == %SSID6% goto CheckDeviceID
if /I %SSID:1025=% == %SSID7% goto CheckDeviceID
if /I %SSID:1025=% == %SSID8% goto CheckDeviceID
echo Fail: This tool does NOT support this project.(SSID:%SSID%)
goto End
@REM Check SSID -E

:CheckDeviceID
@Rem Check dGPU DeviceID -S
echo Checking dGPU and VBIOS version...
if /I %DeviceID:10DE=% == %DeviceID1% goto dGPU1
if /I %DeviceID:10DE=% == %DeviceID2% goto dGPU2
if /I %DeviceID:10DE=% == %DeviceID3% goto dGPU3
if /I %DeviceID:10DE=% == %DeviceID4% goto dGPU4
if /I %DeviceID:10DE=% == %DeviceID5% goto dGPU5
if /I %DeviceID:10DE=% == %DeviceID6% goto dGPU6
if /I %DeviceID:10DE=% == %DeviceID7% goto dGPU7
if /I %DeviceID:10DE=% == %DeviceID8% goto dGPU8
echo Fail: This VBIOS update file does NOT support your graphic card.(DeviceID:%DeviceID%)
goto End
@Rem Check dGPU DeviceID -E

@REM Check VBIOS Version -S
:dGPU1
if /I %Version% == %Version1% goto Fail
echo Start update process...
%EXE1%
goto Pass

:dGPU2
if /I %Version% == %Version2% goto Fail
echo Start update process...
%EXE2%
goto Pass


:dGPU3
if /I %Version% == %Version3% goto Fail
echo Start update process...
%EXE3%
goto Pass


:dGPU4
if /I %Version% == %Version4% goto Fail
echo Start update process...
%EXE4%
goto Pass

:dGPU5
if /I %Version% == %Version5% goto Fail
echo Start update process...
%EXE5%
goto Pass

:dGPU6
if /I %Version% == %Version6% goto Fail
echo Start update process...
%EXE6%
goto Pass

:dGPU7
if /I %Version% == %Version7% goto Fail
echo Start update process...
%EXE7%
goto Pass

:dGPU8
if /I %Version% == %Version8% goto Fail
echo Start update process...
%EXE8%
goto Pass

:Fail
echo Fail: This VBIOS version %Version% has been installed.
goto End
@REM Check VBIOS Version -E

:Pass
REM exit

:End
pause